#include <stdio.h>
#include <string.h>

#include "iocsr_config_cyclone5.h"

#define _GETBYID(PREFIX,ID,POSTFIX) PREFIX##ID##POSTFIX
#define GETBYID(PREFIX,ID,POSTFIX) _GETBYID(PREFIX,ID,POSTFIX)

extern const unsigned long GETBYID(iocsr_scan_chain,CHAIN,_table) [];
int main()
{
  int raw_len = GETBYID(CONFIG_HPS_IOCSR_SCANCHAIN,CHAIN,_LENGTH);
  const unsigned long *raw_data = GETBYID(iocsr_scan_chain,CHAIN,_table);
  unsigned long data[GETBYID(CONFIG_HPS_IOCSR_SCANCHAIN,CHAIN,_LENGTH)/2];
  int byte_len;
  int i;
  for (i=0,byte_len=0; i<raw_len; i+=128)
  {
    unsigned char *buf = (unsigned char*)data+byte_len;
    if (raw_len-i >= 128)
    {
      buf[0] = 0x80;
      buf[1] = 0x7F;
      memcpy(buf+2,&raw_data[i/32],16);
      byte_len += 2+16;
    }
    else
    {
      buf[0] = 0x80;
      buf[1] = (raw_len-i-1);
      memcpy(buf+2,&raw_data[i/32],(raw_len-i+7)/8);
      byte_len += 2+(raw_len-i+7)/8;
    }
  }

  memset((unsigned char*)data+byte_len, 0x00, 3);
  printf("csr%d_len = %d\n", CHAIN, byte_len);
  printf("csr%d_data:\n", CHAIN);
  for (i=0; i<byte_len; i+=4)
  {
    printf("\t.long 0x%08lX\n", data[i/4]);
  }
  return 0;
}

